﻿using System;
using System.Windows.Forms;

namespace SingletonAppWithNotifyIcon
{
    public partial class MainForm2 : Form
    {
        private bool IsQuit { get; set; }

        public MainForm2()
        {
            InitializeComponent();
        }

        private void MyFormClosing(object sender, FormClosingEventArgs e)
        {
            if (IsQuit)
                return;

            HideMe();
            e.Cancel = true;
        }

        private void HideMe()
        {
            Hide();
        }

        public void ShowMe()
        {
            WindowState = FormWindowState.Normal;
            Visible = true;
            Activate();
        }

        private void QuitMe()
        {
            IsQuit = true;
            Application.Exit();
        }

        private void MainForm2_Load(object sender, EventArgs e)
        {
            notifyIcon1.ContextMenu = new ContextMenu();
            notifyIcon1.ContextMenu.MenuItems.Add(new MenuItem("Quit My Fancy App", NotifyIconQuit));
        }

        private void NotifyIconQuit(object sender, EventArgs e)
        {
            QuitMe();
        }

        private void NotifyClick(object sender, EventArgs e)
        {
            ShowMe();
        }

        private void CloseClick(object sender, EventArgs e)
        {
            HideMe();
        }

        private void QuitClick(object sender, EventArgs e)
        {
            QuitMe();
        }
    }
}
